unit XINIFileDemo_Unit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Forms, shellapi,
  XINIFileXE2, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Graphics,
  Vcl.Controls;

type
  TINIFileDemoForm = class(TForm)
    INIPreview: TMemo;
    LoadINI: TButton;
    WriteStringBtn: TButton;
    SectionWr: TEdit;
    IdentWr: TEdit;
    ValueWr: TEdit;
    SectionExistsBtn: TButton;
    IdentExistsBtn: TButton;
    FieldColor: TTimer;
    SectionList: TListBox;
    IdentList: TListBox;
    ReadStringBtn: TButton;
    Instructions: TMemo;
    DonateBtn: TImage;
    OpenDialog1: TOpenDialog;
    XINIFile1: TXINIFile;
    SaveINIBtn: TButton;
    SaveDialog1: TSaveDialog;
    RemoveSectionBtn: TButton;
    RemoveIdentBtn: TButton;
    Label1: TLabel;
    YoutubeBtn: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    emaillink: TLabel;
    Sourceforgebtn: TImage;
    Label5: TLabel;
    Label6: TLabel;
    procedure LoadINIClick(Sender: TObject);
    procedure SectionExistsBtnClick(Sender: TObject);
    procedure IdentExistsBtnClick(Sender: TObject);
    procedure FieldColorTimer(Sender: TObject);
    procedure SectionListClick(Sender: TObject);
    procedure IdentListClick(Sender: TObject);
    procedure ReadStringBtnClick(Sender: TObject);
    procedure DonateBtnClick(Sender: TObject);
    procedure WriteStringBtnClick(Sender: TObject);
    procedure SaveINIBtnClick(Sender: TObject);
    procedure XINIFile1Update(Sender: TObject);
    procedure RemoveSectionBtnClick(Sender: TObject);
    procedure RemoveIdentBtnClick(Sender: TObject);
    procedure YoutubeBtnClick(Sender: TObject);
    procedure SourceforgebtnClick(Sender: TObject);
  private
    { Private declarations }
  public

  end;

var
  INIFileDemoForm: TINIFileDemoForm;


implementation

{$R *.dfm}

procedure TINIFileDemoForm.SectionExistsBtnClick(Sender: TObject);
  var i: integer;
begin
  SectionWr.Color:=clRed;
  FieldColor.Enabled:=false;
  FieldColor.Enabled:=true;

  SectionExistsBtn.Caption:='No';

  i:=XINIFile1.SectionExists(SectionWr.Text);
  if i=-1 then exit;

  SectionExistsBtn.Caption:='Yes @ pos '+inttostr(i);
  SectionWr.Color:=clGreen;
end;

procedure TINIFileDemoForm.IdentExistsBtnClick(Sender: TObject);
  var i: integer;
begin
  SectionExistsBtnClick(SectionExistsBtn);

  IdentWr.Color:=clRed;

  IdentExistsBtn.Caption:='No';

  i:=XINIFile1.IdentExists(SectionWr.Text, IdentWr.Text);
  if i=-1 then exit;

  IdentExistsBtn.Caption:='Yes @ pos '+inttostr(i);
  IdentWr.Color:=clGreen;
end;

procedure TINIFileDemoForm.SectionListClick(Sender: TObject);
begin
  IdentWr.Text:='';
  ValueWr.Text:='';

  IdentList.Clear;
  IdentList.Items.Text:=XINIFile1.IdentsToString(SectionList.Items.Strings[SectionList.ItemIndex]);
  SectionWr.Text:=XINIFile1.Section[SectionList.ItemIndex].name;

  if IdentList.ItemIndex>=0 then
  begin
    IdentWr.Text:=XINIFile1.Section[SectionList.ItemIndex].idents[IdentList.ItemIndex][0];
    ValueWr.Text:=XINIFile1.Section[SectionList.ItemIndex].idents[IdentList.ItemIndex][1];
  end;
end;

procedure TINIFileDemoForm.WriteStringBtnClick(Sender: TObject);
begin
  XINIFile1.WriteString(SectionWr.Text, IdentWr.Text, ValueWr.Text);
end;

procedure TINIFileDemoForm.XINIFile1Update(Sender: TObject);
begin
  SectionList.Items.Text:=XINIFile1.SectionsToString;
  IdentList.Clear;
  SectionWr.Text:='Section';
  IdentWr.Text:='Ident';
  ValueWr.Text:='Value';
  INIPreview.Text:=XINIFile1.RawData;
end;

procedure TINIFileDemoForm.YoutubeBtnClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'https://www.youtube.com/xaidcorp/',nil,nil, SW_SHOWNORMAL) ;
end;

procedure TINIFileDemoForm.IdentListClick(Sender: TObject);
begin
  if IdentList.ItemIndex>=0 then
  begin
    IdentWr.Text:=XINIFile1.Section[SectionList.ItemIndex].idents[IdentList.ItemIndex][0];
    ValueWr.Text:=XINIFile1.Section[SectionList.ItemIndex].idents[IdentList.ItemIndex][1];
  end;
end;

procedure TINIFileDemoForm.SourceforgebtnClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://sourceforge.net/projects/xinifile/',nil,nil, SW_SHOWNORMAL) ;
end;

procedure TINIFileDemoForm.ReadStringBtnClick(Sender: TObject);
begin
  Showmessage( XINIFile1.ReadString(SectionWr.Text, IdentWr.Text) );
end;

procedure TINIFileDemoForm.RemoveIdentBtnClick(Sender: TObject);
begin
  XINIFile1.RemoveIdent(SectionWr.Text, IdentWr.Text);
end;

procedure TINIFileDemoForm.RemoveSectionBtnClick(Sender: TObject);
begin
  XINIFile1.RemoveSection(SectionWr.Text);
end;

procedure TINIFileDemoForm.LoadINIClick(Sender: TObject);
begin
  OpenDialog1.Execute(self.Handle);
  XINIFile1.LoadINI(OpenDialog1.FileName);
  XINIFile1Update(XINIFile1);
end;

procedure TINIFileDemoForm.DonateBtnClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=E6E4NBE7CDBQG',nil,nil, SW_SHOWNORMAL) ;
end;

procedure TINIFileDemoForm.FieldColorTimer(Sender: TObject);
begin
  SectionWr.Color:=clWindow;
  IdentWr.Color:=clWindow;
  SectionExistsBtn.Caption:='Section Exists?';
  IdentExistsBtn.Caption:='Ident Exists?';
  FieldColor.Enabled:=false;
end;

procedure TINIFileDemoForm.SaveINIBtnClick(Sender: TObject);
begin
  SaveDialog1.Execute(handle);
  XINIFile1.SaveINI(SaveDialog1.FileName);
end;

end.
